//************************************************************************
// Program Name	: Read an Integer value with some limits 0-100
// Programmer	: Petros Panayi	Stud. ID: 000000
// Date  Modif.	: 1 Sep 2017
//************************************************************************
// Comments: Read an Integer value with some limits 0-100
//************************************************************************

    .data
input_message_str:	.asciz	"Please Enter the an Integer between 0 and 100:"
message_str: 		.string	"Thanks. You Have Done it !!!\n"
int_scanf_str: 		.string	"%d"
//************************************************************************	
	.text
	.global	main
main:

	stp	X29, X30, [sp, -32]!	//	First (!) move the stack pointer 32 bytes down (sp-32)
								//  and then store double x29 and x30. 
								// (pre-index modes whih means apply the offset before accessing the memory)
	add	x29, sp, 0				//	Copy the value of stack pointer to Frame Pointer

//******** Print Input Message ****************
Question:
	adr 	x0, input_message_str		// Load the Address of input_message_str
	bl		printf				    	// Call Function printf
//******** Read the Value ************	
	add		x1, x29, 28			// Set the location to store the input value (fp+28)
	adr 	x0, int_scanf_str	// Load the Address of input_message_str
	bl		scanf				// Call Function scanf
	
	ldr		w20, [x29, 28]		// Load the Integer value in register w20
	subs	wzr, w20, 0 		// Do not waist registers use wzr
	b.mi	Question			// Go back to get the value again.
	subs	wzr, w20, 100 
	b.pl	Question			// Go back to get the value again.	
	adr 	x0, message_str		// Load the address of the message to be encrypted
	bl		printf
	
	ldp	x29, x30, [sp], 32		// Release the stack space
	ret							// Return to loading function
//************************************************************************
